#include "gfx.h"
#include <stdlib.h>
#include "hw_md.h"

void print_string(const char * string, uint16_t plane, uint32_t x, uint32_t y) {
	if (string == NULL) {
		return;
	}

	SET_VDP_REG(15, 2);
	ACCESS_VDP(VRAM_W, plane + SCREEN_LOC(x, y));
	for (size_t i = 0; string[i] != '\0'; i++) {
		DATA_PORT_WORD(string[i]);
	}
}

void tile_rectangle(uint16_t tile, uint16_t plane, uint16_t x, uint16_t y, uint16_t width, uint16_t height) {
	SET_VDP_REG(15, 2);
	for (uint16_t iy = 0; iy < height; iy++) {
		ACCESS_VDP(VRAM_W, plane + SCREEN_LOC(x, y + iy));
		for (uint16_t ix = 0; ix < width; ix++) {
			DATA_PORT_WORD(tile);
		}
	}
}
