#include "segarand.h"

#define RNG_CONST_A 0x2A6D365A
#define RNG_CONST_B 0x41C64E6D
#define HI(lw) ((lw) & 0xFFFF0000)
#define LO(lw) ((lw) & 0xFFFF)
#define LW(lw) ((lw) << 16)
#define RW(lw) ((lw) >> 16)

/* As can be seen at a glance, the System 16 and B-System randomizers are
 * completely different. */

uint32_t next_int_a(uint32_t * seedp) {
	uint32_t temp, oldseed;

	temp = (*seedp == 0) ? RNG_CONST_A : *seedp;
	oldseed = temp;
	temp *= 41;
	*seedp = temp + LW(temp);
	return (LO(temp) + RW(temp)) | HI(oldseed);
}

void new_seq_a(uint8_t * seq, size_t len, uint32_t * seedp) {
	size_t i;

	for (i = 0; i < len; i++) {
		seq[i] = (next_int_a(seedp) & 0x3F) % 7;
	}
}

uint8_t next_piece_b(uint32_t * seedp) {
	uint32_t piece, oldseed;

	oldseed = *seedp;

	*seedp  = LW(RW(RNG_CONST_B) * LO(oldseed));
	*seedp +=    LO(RNG_CONST_B) * LO(oldseed) ;
	*seedp += LW(LO(RNG_CONST_B) * RW(oldseed));
	*seedp += 12345;

	piece = RW(*seedp) ^ LO(*seedp);
	piece &= 0x3F;
	piece %= 7;
	piece++;

	return piece;
}
