#pragma once

#include <stdint.h>
#include <stdlib.h>

#define SEQ_LEN 1000

/* Used in tetris1, tetris2, tetris3, and tetris. */
/* Pseudorandomly generate the next 32-bit unsigned integer. */
uint32_t next_int_a(uint32_t * seedp);
/* Pseudorandomly generate a sequence of 'len' integers [0,6] in the array
 * pointed to by 'seq'.
 *
 * 0=I 1=Z 2=S 3=O 4=T 5=L 6=J */
void new_seq_a(uint8_t * seq, size_t len, uint32_t * seedp);


/* Used in tetrist and tetrista. */
/* Pseudorandomly generate next piece integer in [1,7].
 * 
 * 1=I 2=L 3=J 4=S 5=S 6=T 7=O */
uint8_t next_piece_b(uint32_t * seedp);
